keywords = {'red', 'green', 'blue'};
descriptors = {'ab_hist21'};
N = 21;
s = samples(descriptors{1});
FontSize = 18;

% compute z values
z_values = computeZ(keywords, descriptors);

% histogram bin centers
a = 160*linspace(0, 1, N)-80;
b = 160*linspace(0, 1, N)-80;
    
figure(1);
hold off

subplot(2, 3, 5);
% imagesc(reshape(s, N, N, 3));
% keyboard
surf(repmat(a', 1, N), repmat(b, N, 1), zeros(N), reshape(s, N, N, 3), 'facecolor', 'texture', 'LineStyle', 'none');
view(0, 90)
xlabel('a', 'FontSize', FontSize);
ylabel('b', 'FontSize', FontSize);
set(gca, 'XTick', [-80 -40 0 40 80], 'FontSize', FontSize);
set(gca, 'YTick', [-80 -40 0 40 80], 'FontSize', FontSize);
axis equal;
xlim([-80 80]);
ylim([-80 80]);
title('bin center colors', 'FontSize', FontSize);

for i = 1:3
    % get z values for current keyword. set meaningless values to -Inf
    z = z_values{i};
    z(z==Inf) = -Inf;
    z(imag(z)>1e-6) = -Inf;
    
    % display z values in new subplot
    subplot(2, 3, i);
    surf(repmat(a', 1, N), repmat(b, N, 1), zeros(N), z, 'facecolor', 'texture', 'LineStyle', 'none');
    view(0, 90)
    xlabel('a', 'FontSize', FontSize);
    ylabel('b', 'FontSize', FontSize);
    set(gca, 'XTick', [-80 -40 0 40 80], 'FontSize', FontSize);
    set(gca, 'YTick', [-80 -40 0 40 80], 'FontSize', FontSize);
    axis equal;
    xlim([-80 80]);
    ylim([-80 80]);
    colormap gray;
    colorbar;
    title(keywords{i}, 'FontSize', FontSize);
end
