function [descs, N, ids] = collect(name, varargin)
init;

FORCE = opts.FORCE || opts.FORCE_COLLECT;
% keyboard
% FORCE = 1;

% default values
kw = 0;
posnr = 0;

% parse varargin
i = 1;
while i <= size(varargin, 2)
    if isnumeric(varargin{i})
        posnr = varargin{i};
    elseif ischar(varargin{i})
        kw = varargin{i};
    else
        error('mycollect: unrecognized input argument %s', varargin{i});
    end
    i = i+1;
end

fnameall = sprintf(opts.collPath, name, '__all__');
if kw == 0
    fname = fnameall;
else
    kw = lower(kw);
    if posnr > 0
        fname = sprintf(opts.collPath, name, [kw '_' num2str(posnr)]);
    else
        fname = sprintf(opts.collPath, name, kw);
    end
end

% keyboard

fprintf('%s ... ', fname);
if exist(fname, 'file') && ~FORCE
	load(fname, 'descs');
    fprintf('loaded\n');
else
    if exist(fnameall, 'file') && ~FORCE
        fprintf('collecting from m file\n');
        load(fnameall, 'descs', 'ids');
    else
        fprintf('collecting from hd\n');
        % getting all descriptors from hd and put into file
        [tfs ids] = query(0);
        
        descs = cell(length(ids), 1);
        for i = 1:length(ids)
            fprintf('%d/%d ', i, length(ids));
            descs{i} = single(describe(ids(i), name));
        end
        save(fnameall, 'descs', 'ids', '-v7.3');
        
        if kw == 0
            N = numel(size(descs{1}));
            return;
        end
    end
%     keyboard
    % ids corresponding to the kw
    [tfs ids] = myquery(kw, 'pos', posnr);
    
    descs = descs(tfs);
    ids = ids(tfs);
    save(fname, 'descs', 'ids');
end
N = numel(size(descs{1}));

