function zmatrix = computeZ(kws, desctypes)

init;
FORCE = opts.FORCE || opts.FORCE_Z;
% FORCE = 1;
% keyboard

% fname = sprintf(opts.compPath, desctype);
zmatrix = cell(length(desctypes), length(kws));
Nkws = cell(length(desctypes), length(kws));


dsttype = 'rs';

% keyboard
for d = 1:length(desctypes)
    desctype = desctypes{d};
    if exist('desc_all', 'var');
        clear desc_all;
    end
        
    for k = 1:length(kws)
        tic
        kw = kws{k};

        fname = sprintf(opts.distPath, dsttype, kw , desctype);
        fprintf('%s', fname);
        
        warning('off', 'MATLAB:load:variableNotFound');
        if exist(fname, 'file') && ~FORCE
           load(fname, 'zvalues', 'Nkw');
        end
        
        if exist('zvalues', 'var') && exist('Nkw', 'var') && ~FORCE
           fprintf(' ... loaded\n');
        else % cannot load from file, have to compute distances
            fprintf(' ... computing\n');
            if ~exist('desc_all', 'var');
                desc_all = collect(desctype);
                Sbins = size(desc_all{1});
                Nbins = numel(desc_all{1});
                Ncell = length(desc_all);
                desc_all = reshape(desc_all, [ones(size(Sbins)) Ncell]);
                desc_all = cell2mat(desc_all);
                desc_all = reshape(desc_all, Nbins, Ncell);
                desc_all = desc_all';
            end
            
            tfs = query(kws{k});
            Nkw = sum(tfs);
            
            if Nkw < 10
                fprintf('WARNING (mydistances): Only %d image(s) for kws "%s".\n', Nkw, kw);
            end
%             keyboard
            ntfs = query(kws{k}, 'not');
%             Nnkw = sum(ntfs);

%             keyboard
            zvalues = zeros(1,Nbins);
            for i=1:Nbins
                % compare images with a keyword against images without a keyword
                [~, ~, stat] = ranksum(desc_all(tfs, i), desc_all(ntfs, i));
                % compare images with a keyword against all images
%                 [~, ~, stat] = ranksum(desc_all(tfs, i), desc_all(:, i));
                zvalues(i) = stat.zval;
                
                % my own ranksum method
%                 zvalues(i) = mexrs(desc_all(tfs, i), desc_all(:, i));
            end
            zvalues = reshape(zvalues, Sbins);
%             keyboard
 
            mkpath(fname);
            save(fname, 'zvalues', 'Nkw');
            
            toc
        end
        Nkws{d, k} = Nkw;
        zmatrix{d, k} = zvalues;
        clear('zvalues');
    end
end

