import flickrapi
import xml.etree.ElementTree as ET
import pdb
import os
import codecs
from unidecode import unidecode
import os.path
import time


api_key = ''
api_secret = ''

if api_key == '':
	print("\nPlease get an account from Flickr and get a key and a secret to access the API.")
	print("Once you have this you can just paste them into the two variables at the very top of this script.\n")
	quit()

#pdb.set_trace()

NMAX = 300 #download NMAX images for every keyword in kws array


flickr = flickrapi.FlickrAPI(api_key, api_secret)
file_id_kw = codecs.open('flickr_id_kw.txt', 'a', "latin_1")
file_photos = codecs.open('flickr_photos.txt', 'a', "latin_1")
file_tags = codecs.open('flickr_tags.txt', 'a', "latin_1")

kws = ('red', 'green', 'blue')

owners = []

N = 0
for i in range(len(kws)):
	kw = kws[i]
	#pdb.set_trace()
	print("NEW KW: " + kw)
	print("resetting N from " + str(N) + " to 0")
	N = 0
	try:
		for photo in flickr.walk(tag_mode='all', tags=kw):
			# get necessary to download image
			farm_id = photo.attrib["farm"]
			server_id = photo.attrib["server"]
			photo_id = photo.attrib["id"]
			secret = photo.attrib["secret"]
			owner = photo.attrib["owner"]
			fname = "./images/" + photo_id + ".jpg"
			print("CHECK " + fname)
#			pdb.set_trace()
			
			goodone = 1
			# check whether I recently downloaded an image of that owner
			for o in owners:
				if o == owner:
					goodone = 0
					print("recently downloaded from owner " + owner)
					for o in owners:
						print(o)
						
			# check whether I already have that file
			if os.path.isfile(fname):
				goodone = 0
				print("file already exists")


			if goodone:
				print("OK")
#				pdb.set_trace()
				url = "http://farm" + farm_id + ".static.flickr.com/" + server_id + "/" + photo_id + "_" + secret + "_b.jpg"
				print("GET " + url)
# wget might get an answer "HTTP request sent, awaiting response... 302 Moved Temporarily" and is then redirected to an image saying "This photo is currently unavailable". The max-redirect option avoids this.
				command = "wget --max-redirect=0 " + url + " -O " + fname
#				pdb.set_trace()
				response = os.system(command)
				if response == 0: #file directly found
					print('RECEIVED')
					
					# update list of owners I've been downloaded from
					if len(owners) >= 10:
						owners.pop(0)
					owners.append(owner)
					
					# get all tag information about image
					tags = flickr.tags_getListPhoto(api_key = api_key, photo_id = photo_id)
					p2 = tags.find("photo/tags")
					l2 = p2.getiterator("tag")
					raw_kws = ''
					first = 1
					for ii in l2:
						raw_kw = ii.attrib["raw"]
						if first:
							raw_kws = "<<" + raw_kw + ">>"
							first = 0
						else:
							raw_kws = raw_kws + " <<" + raw_kw + ">>"
			
					# clean up string of keywords
					raw_kws = unidecode(raw_kws)
					print("clean annotation: " + raw_kws)
				
					# output to different files
					file_id_kw.write(photo_id + "\t")
					file_id_kw.write(raw_kws)	
					file_id_kw.write("\n")
					file_id_kw.flush()
				
					file_photos.write(url + "\n")
					file_photos.write(ET.tostring(photo) + "\n\n")
					file_tags.write(ET.tostring(tags) + "\n\n")
					file_photos.flush()
					file_tags.flush()				
				
					N = N + 1
					print("KW = [" + kw + "]  N = " + str(N) + " (" + str(NMAX) + ")" + "\n")
#					pdb.set_trace()
				else:
					print('SKIP, N=' + str(N))
#					pdb.set_trace()
					command = "rm ./images/" + photo_id + ".jpg"
					os.system(command)
				#end if response == 0
			else:
				print("REJECT FILE")
			
		
			if N == NMAX:
				print("BREAKING LOOP AFTER " + str(N) + " IMAGES")
				break
				
	except Exception: # if there is any error we wait a bit and try with the next keyword
		print("EXCEPTION, stopping keyword " + kw)
		print("waiting 60s before continue")
		time.sleep(60)
		pass
