function [tfs, ids] = myquery(kw, varargin)
% [tfs ids favs Lanno pos kws] = myquery(kw, 'not', 'pos', 0)

init;
FORCE = opts.FORCE || opts.FORCE_QUERY;
% FORCE = 1;
% keyboard

% default values
negate = false;

% parse varargin
i = 1;
while i <= size(varargin, 2)
    switch varargin{i}
        case 'not'
            negate = true;
    end
    i = i+1;
end


if kw == 0
    fname = sprintf(opts.queryPath, '__all__');
else
    if negate == false
        fname = kw;
    else
        fname = [kw '_not'];
    end
    fname = sprintf(opts.queryPath, fname);
end
% keyboard

success = 0;
fprintf('%s ... ', fname);
if exist(fname, 'file') && ~FORCE
    success = 1;
    try
        load(fname, 'tfs', 'ids');
    catch
        success = 0;
    end
end

if success == 1
	fprintf('loaded\n');
else
    fprintf('querying ... ');
    % read flickr database
    fid = fopen(opts.DB);
    c = textscan(fid, '%u64 %s', 'delimiter', '\t', 'bufsize', 100000);
    fclose(fid);
    ids = c{1}; kws = c{2};

    if kw == 0
        tfs = true(length(ids), 1);
    else
        tfs = false(length(ids), 1);
    
%       keyboard
        for i = 1:length(ids)
            if negate == false && ~isempty(regexpi(['.' lower(kws{i})], ['\W+?' kw '\W+?']))
                tfs(i) = true;
            elseif negate == true && isempty(regexpi(['.' lower(kws{i})], ['\W+?' kw '\W+?']))
                tfs(i) = true;
            end
        end
    end
	
    if kw~=0
        ids = ids(tfs);
    end
    
%     keyboard
    save(fname, 'ids', 'tfs');
    
    fprintf('done\n');
end

