function out = samples(type)
% out = samples(type)
%
% rgb values for all bins in descriptor defined by type
%
% example usage:
% out = samples('lab_hist9');

switch type
    case {'lab_hist9'}
        l = 100*linspace(1/18, 1-1/18, 9)';
        l = repmat(l, [1 9 9]);
        a = 160*linspace(1/18, 1-1/18, 9)-80;
        a = repmat(a, [9 1 9]);
        b = reshape(160*linspace(1/18, 1-1/18, 9)-80, [1 1 9]);
        b = repmat(b, [9 9 1]);
        
        out = mexLab2sRGB([l(:) a(:) b(:)]);

    case {'ab_hist21'}
        l = 50*ones(21);
        a = 160*linspace(1/42, 1-1/42, 21)'-80;
        a = repmat(a, [1 21]);
        b = 160*linspace(1/42, 1-1/42, 21)-80;
        b = repmat(b, [21 1]);
        
        out = mexLab2sRGB([l(:) a(:) b(:)]);
end
